SystemOrganization addCategory: #BugFinder!

Object subclass: #Bug
	instanceVariableNames: 'exception message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BugFinder'!

!Bug methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/19/2011 18:49'!
= anObject
	^ (self isKindOf: Bug)
		and: [ message = anObject message
		and: [ exception signaler = anObject exception signaler
		and: [ exception messageText = anObject exception messageText ] ] ].! !

!Bug methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/19/2011 18:21'!
exception
	^ exception.! !

!Bug methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/19/2011 18:21'!
exception: anException
	exception := anException.! !

!Bug methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/19/2011 18:20'!
message
	^ message.! !

!Bug methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/19/2011 18:21'!
message: aMessage
	message := aMessage.! !

Object subclass: #BugFinder
	instanceVariableNames: 'generator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BugFinder'!

!BugFinder class methodsFor: 'as yet unclassified' stamp: 'GonzaloMunoz 12/19/2011 20:34'!
tryUnarySelectors: anInstance iterations: numberOfIterations
	^ self new tryUnarySelectors: anInstance iterations: numberOfIterations.! !

!BugFinder methodsFor: 'accessing' stamp: 'GonzaloMunoz 12/14/2011 22:30'!
generator: aRandom
	generator := aRandom.! !

!BugFinder methodsFor: 'initialization' stamp: 'GonzaloMunoz 12/14/2011 22:28'!
initialize
	generator := Random new.! !

!BugFinder methodsFor: 'public' stamp: 'GonzaloMunoz 12/19/2011 20:29'!
tryUnarySelectors: anInstance iterations: numberOfIterations
	| bugsPerIteration exception point caughtBugs bug selector |
	bugsPerIteration := OrderedCollection new.
	caughtBugs := OrderedCollection new.
	numberOfIterations
		timesRepeat: [ 
			selector := (self understandableUnarySelectorsOf: anInstance) atRandom: generator.
			[ anInstance perform: selector ]
				on: Exception
				do: [ :ex | 
					bug := Bug new
						exception: ex;
						message: selector;
						yourself.
					(ex signaler == anInstance or: [ caughtBugs anySatisfy: [ :each | each = bug ] ])
						ifFalse: [ caughtBugs add: bug ] ].
			bugsPerIteration
				add:
					(OrderedCollection new
						addAll: caughtBugs;
						yourself) ].
	^ bugsPerIteration! !

!BugFinder methodsFor: 'util' stamp: 'GonzaloMunoz 12/19/2011 14:26'!
understandableUnarySelectorsOf: anInstance
	^ anInstance class selectors select: [ :s | s isUnary and: [ (s equalsTo: 'initialize') not ] ]! !
